You can not select more than 25 topics Topics must start with a letter or number, can include dashes ('-') and can be up to 35 characters long.

203 lines
4.7 KiB

  1. #!/bin/bash
  2. # SPDX-License-Identifier: GPL-3.0+
  3. # Copyright (C) 2018, Martin Kepplinger <martink@posteo.de>
  4. RED='\033[0;31m'
  5. GREEN='\033[0;32m'
  6. NC='\033[0m'
  7. set -e
  8. have_input_image=0
  9. have_chipname=0
  10. have_backupname=0
  11. have_flasher=0
  12. usage()
  13. {
  14. echo "Skulls for the X230"
  15. echo " Run this script on an external computer with a flasher"
  16. echo " connected to the X230's top chip (closer to the display"
  17. echo " and farther from you)"
  18. echo ""
  19. echo "Usage: $0 -i <image.rom> [-c <chipname>] [-k <backup_filename>]"
  20. echo ""
  21. echo " -f <hardware_flasher>"
  22. echo " supported flashers: rpi, ch341a"
  23. echo ""
  24. echo " -i <path to image to flash>"
  25. echo " -c <chipname> to use for flashrom"
  26. echo " -k <path to backup to save>"
  27. }
  28. args=$(getopt -o f:i:c:k:h -- "$@")
  29. if [ $? -ne 0 ] ; then
  30. usage
  31. exit 1
  32. fi
  33. eval set -- "$args"
  34. while [ $# -gt 0 ]
  35. do
  36. case "$1" in
  37. -f)
  38. FLASHER=$2
  39. have_flasher=1
  40. shift
  41. ;;
  42. -i)
  43. INPUT_IMAGE_PATH=$2
  44. have_input_image=1
  45. shift
  46. ;;
  47. -c)
  48. CHIPNAME=$2
  49. have_chipname=1
  50. shift
  51. ;;
  52. -k)
  53. BACKUPNAME=$2
  54. have_backupname=1
  55. shift
  56. ;;
  57. -h)
  58. usage
  59. exit 1
  60. ;;
  61. --)
  62. shift
  63. break
  64. ;;
  65. *)
  66. echo "Invalid option: $1"
  67. exit 1
  68. ;;
  69. esac
  70. shift
  71. done
  72. command -v flashrom >/dev/null 2>&1 || { echo -e >&2 "${RED}Please install flashrom and run as root${NC}."; exit 1; }
  73. command -v mktemp >/dev/null 2>&1 || { echo -e >&2 "${RED}Please install mktemp (coreutils)${NC}."; exit 1; }
  74. if [ ! "$have_input_image" -gt 0 ] ; then
  75. image_available=$(ls -1 | grep x230_coreboot_seabios || true)
  76. if [ -z "${image_available}" ] ; then
  77. echo "No image file found. Please add -i <file>"
  78. echo ""
  79. usage
  80. exit 1
  81. fi
  82. prompt="file not specified. Please select a file to flash:"
  83. options=( $(find -maxdepth 1 -name "x230_coreboot_seabios*rom" -print0 | xargs -0) )
  84. PS3="$prompt "
  85. select INPUT_IMAGE_PATH in "${options[@]}" "Quit" ; do
  86. if (( REPLY == 1 + ${#options[@]} )) ; then
  87. exit
  88. elif (( REPLY > 0 && REPLY <= ${#options[@]} )) ; then
  89. echo "You picked $INPUT_IMAGE_PATH which is file $REPLY"
  90. break
  91. else
  92. echo "Invalid option. Try another one."
  93. fi
  94. done
  95. fi
  96. if [ ! "$have_flasher" -gt 0 ] ; then
  97. echo "Please select the hardware you use:"
  98. PS3='Please select the hardware flasher: '
  99. options=("Raspberry Pi" "CH341A" "Quit")
  100. select opt in "${options[@]}"
  101. do
  102. case $opt in
  103. "Raspberry Pi")
  104. FLASHER="rpi"
  105. break
  106. ;;
  107. "CH341A")
  108. FLASHER="ch341a"
  109. break
  110. ;;
  111. "Quit")
  112. exit 0
  113. ;;
  114. *) echo invalid option;;
  115. esac
  116. done
  117. fi
  118. programmer=""
  119. if [ "${FLASHER}" = "rpi" ] ; then
  120. echo "Ok. Run this on a Rasperry Pi."
  121. programmer="linux_spi:dev=/dev/spidev0.0,spispeed=128"
  122. elif [ "${FLASHER}" = "ch341a" ] ; then
  123. echo "Ok. Connect a CH341A programmer"
  124. programmer="ch341a_spi"
  125. else
  126. echo "invalid flashrom programmer"
  127. usage
  128. exit 1
  129. fi
  130. TEMP_DIR=$(mktemp -d)
  131. if [ ! -d "$TEMP_DIR" ]; then
  132. echo "${RED}Error:${NC} Could not create temp dir"
  133. exit 1
  134. fi
  135. if [ ! "$have_chipname" -gt 0 ] ; then
  136. echo "trying to detect the chip..."
  137. flashrom -p ${programmer} &> "${TEMP_DIR}"/chips || true
  138. flashrom_error=""
  139. flashrom_error=$(cat "${TEMP_DIR}"/chips | grep -i error || true)
  140. if [ ! -z "${flashrom_error}" ] ; then
  141. cat "${TEMP_DIR}"/chips
  142. rm -rf "${TEMP_DIR}"
  143. exit 1
  144. fi
  145. CHIPNAME=""
  146. chip_found=0
  147. CHIPNAME=$(cat "${TEMP_DIR}"/chips | grep Found | grep "MX25L3206E" | grep -o '".*"' || true)
  148. if [ ! -z "${CHIPNAME}" ] ; then
  149. chip_found=1
  150. fi
  151. if [ ! "$chip_found" -gt 0 ] ; then
  152. echo "chip not detected."
  153. flashrom -p ${programmer}
  154. rm -rf "${TEMP_DIR}"
  155. echo "Please find it manually in the list above and rerun with the -c parameter."
  156. exit 1
  157. else
  158. echo -e "Detected ${GREEN}${CHIPNAME}${NC}."
  159. fi
  160. fi
  161. INPUT_IMAGE_NAME=$(basename "${INPUT_IMAGE_PATH}")
  162. INPUT_IMAGE_SIZE=$(wc -c < "$INPUT_IMAGE_PATH")
  163. reference_filesize=4194304
  164. if [ ! "$INPUT_IMAGE_SIZE" -eq "$reference_filesize" ] ; then
  165. echo -e "${RED}Error:${NC} input file must be 4MB of size"
  166. exit 1
  167. fi
  168. echo "verifying SPI connection by reading 2 times. please wait."
  169. flashrom -p ${programmer} -c "${CHIPNAME}" -r "${TEMP_DIR}"/test1.rom
  170. flashrom -p ${programmer} -c "${CHIPNAME}" -r "${TEMP_DIR}"/test2.rom
  171. cmp --silent "${TEMP_DIR}"/test1.rom "${TEMP_DIR}"/test2.rom
  172. if [ "$have_backupname" -gt 0 ] ; then
  173. cp "${TEMP_DIR}"/test1.rom "${BACKUPNAME}"
  174. echo "current image saved as ${BACKUPNAME}"
  175. fi
  176. TEMP_SIZE=$(wc -c < "$TEMP_DIR/test1.rom")
  177. if [ ! "$INPUT_IMAGE_SIZE" -eq "$TEMP_SIZE" ] ; then
  178. echo -e "${RED}Error:${NC} read image (${TEMP_SIZE}) has different size that new image $INPUT_IMAGE_NAME (${INPUT_IMAGE_SIZE})"
  179. exit 1
  180. fi
  181. rm -rf "${TEMP_DIR}"
  182. echo -e "${GREEN}connection ok${NC}. flashing ${INPUT_IMAGE_NAME}"
  183. flashrom -p ${programmer} -c "${CHIPNAME}" -w "${INPUT_IMAGE_PATH}"
  184. echo -e "${GREEN}DONE${NC}"